

#include "global.h"

#include "vsds.h"


/* *****************************************************************************
***************************************************************************** */
int sds_platform::init(iface *isim) {

   symbol_correlation_type *str;
   correlate *basis;

   for (str=(symbol_correlation_type *)symbol_lut.head; str && str->sym_sds != type; str=(symbol_correlation_type *)str->next);

   if (!str) {
      if (logfile)
         fprintf(logfile, "WARNING: Unable to identify entity # %d\n", type);

      return 0;
   }
         
   // find type
   if (!((sds_iface *)isim)->platman.head) {
      if (logfile)
         fprintf(logfile, "No correlation table\n");
      return 0;
   }

   basis = ((correlate *)((sds_iface *)isim)->platman.head)->find(type);

   if (!basis) {
      if (logfile)
         fprintf(logfile, "Warning:Bad Correlation Code %d\n", type);
      return 0;
   }

   if (((str->sym_3D/1000) % 100) == 2 || ((str->sym_3D/100000000) % 100) == 2)
      platform_flag |= PLATFORM_FLAG_FLY;
   
   // create rendering object
   if (vis_data) {
      delete vis_data;
      vis_data = NULL;
   }

   vis_data = ((platform_data *(*)(basic_platform *))isim->data_loader)(this);

   if (!vis_data->init(isim, basis, str)) {
      delete vis_data;
      vis_data = NULL;
      return 0;
   }

   return 1;
}


/* *****************************************************************************
   pseudo replacement for update_data
***************************************************************************** */
void sds_platform::update_position(double *xyz, double *pyr, double *machine_time, double *newtime) {

   plat_clone.init_pos[0] = plat_clone.pos[0] = xyz[0]; 
   plat_clone.init_pos[1] = plat_clone.pos[1] = xyz[2];
   plat_clone.init_pos[2] = plat_clone.pos[2] = -xyz[1];
      
   plat_clone.rpy[0] = pyr[2];
   plat_clone.rpy[1] = pyr[0];
   plat_clone.rpy[2] = pyr[1];

   plat_clone.machine_time = *machine_time - (*newtime - plat_clone.timer);
   plat_clone.timer = *newtime;
   plat_clone.elapsed_time = 0;

   //note: this line is kinda mute point as it gets wiped later, before
   // rendering, though luckily not used by pix_data class
   platform_flag |= PLATFORM_FLAG_UPDATE;
}
